/****************************************************************************/
/* |\   ======   /| **              IDRepl              ** |\   ======   /| */
/* |__\========/__| **       MasarLabs ID-Replacer      ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: adb.hpp,v 1.2 2000/12/16 16:05:05 cvs Exp $
*****************************************************************************/
#ifndef  _MASARLABS_ADB_HPP_
#define  _MASARLABS_ADB_HPP_

#include <iostream>

class ASCII_DB_RECORD;                         // Forward declaration

/****************************************************************************/
/*                               class ASCII_DB                             */
/****************************************************************************/
class ASCII_DB
   {
   private:
      /**********************************************************************/
      /*                            Private Data                            */
      /**********************************************************************/
      PSZ       psz_Buff;
      PSZ       psz_BuffPos;
      PSZ       psz_BuffEnd;
      INT       i_BuffSize;
      PCSZ    * apcsz_Fields;
      INT       i_FieldsSize;
      INT       i_FieldsUsed;
      istream & is_IStream;
      LONG      l_StreamPos;
      CHAR      ch_FieldSep;
      PCSZ      pcsz_Default;

      /**********************************************************************/
      /*                         Private Functions                          */
      /**********************************************************************/
      ASCII_DB (const ASCII_DB & obj);               // Don't Use
      ASCII_DB & operator= (const ASCII_DB & obj);   // Don't Use

      APIRET ReadBuffer (VOID);
      APIRET ReallocBuffer (VOID);

      APIRET AddField (PCSZ pcszField);
      APIRET ReallocField (VOID);
      APIRET RecalcField (PCSZ pcszNewField0);
      APIRET ResetField (VOID);
//      APIRET TerminateField (VOID);

   public:
      /**********************************************************************/
      /*                          Public Functions                          */
      /**********************************************************************/
      ASCII_DB (istream & isIStream, CHAR chFieldSep = '\t',
                    PCSZ pcszDefault = NULL);

      APIRET Next (VOID);

      PCSZ operator [] (INT i) const
         {
         return (((i < i_FieldsUsed) && (i >= 0)) ?
                  apcsz_Fields[i] : pcsz_Default);
         }

      INT  QueryFields (VOID) const       { return (i_FieldsUsed); }
      LONG QueryPos (VOID) const          { return (l_StreamPos); }

      APIRET CopyRecord (ASCII_DB_RECORD & mclAdbRecord);
   };  /* end-class ASCII_DB */

/****************************************************************************/
/*                           class ASCII_DB_RECORD                          */
/****************************************************************************/
class ASCII_DB_RECORD
   {
   private:
      /**********************************************************************/
      /*                            Private Data                            */
      /**********************************************************************/
      PSZ       psz_Buff;
      INT       i_BuffSize;
      PCSZ    * apcsz_Fields;
      INT       i_FieldsSize;
      INT       i_FieldsUsed;
      PCSZ      pcsz_Default;

      /**********************************************************************/
      /*                         Private Functions                          */
      /**********************************************************************/
      ASCII_DB_RECORD (const ASCII_DB_RECORD & obj);
      ASCII_DB_RECORD & operator= (const ASCII_DB_RECORD & obj);

   public:
      /**********************************************************************/
      /*                          Public Functions                          */
      /**********************************************************************/
      ASCII_DB_RECORD (PCSZ pcszDefault = NULL);
      ~ASCII_DB_RECORD (VOID);

      PCSZ operator [] (INT i) const
         {
         return (((i < i_FieldsUsed) && (i >= 0)) ?
                  apcsz_Fields[i] : pcsz_Default);
         }

      INT  QueryFields (VOID) const       { return (i_FieldsUsed); }

      friend APIRET ASCII_DB::CopyRecord (
                  ASCII_DB_RECORD & mclAdbRecord);
   };  /* end-class ASCII_DB_RECORD */

/****************************************************************************/
#endif   // !defined (_MASARLABS_ADB_HPP_)
