/****************************************************************************/
/* |\   ======   /| **              IDRepl              ** |\   ======   /| */
/* |__\========/__| **       MasarLabs ID-Replacer      ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: idrepl.hpp,v 1.16 2003/11/19 15:47:31 cvs Exp $
*****************************************************************************/
#ifndef  _MASARLABS_IDREPL_HPP_
#define  _MASARLABS_IDREPL_HPP_

#include <iostream>
#include <vector>
#include <string>
#include <ext/hash_map>

using namespace std;

/****************************************************************************/
/* Types                                                                    */
/****************************************************************************/

#define VOID    void

#define BOOL    bool
#define CHAR    char
#define INT     int
#define LONG    long

#define UCHAR   unsigned char
#define UINT    unsigned int
#define USHORT  unsigned short
#define ULONG   unsigned long

#define PSZ     char *
#define PCSZ    const char *

#define STRING   string
#define STACK    stack
#define VECTOR   vector
#define HASH_MAP __gnu_cxx::hash_map

#define APIRET   INT

/****************************************************************************/
/* Costants                                                                 */
/****************************************************************************/

#undef  TRUE
#define TRUE     true
#undef  FALSE
#define FALSE    false

#ifndef  NULL
 #define NULL (0)
#endif

#define NIL (0)

/****************************************************************************/
/* Costants                                                                 */
/****************************************************************************/

extern PCSZ pcsz_ProgName;
extern INT  i_MaxLevel;
extern BOOL f_Remove;
extern PCSZ pcsz_DelimStart;
extern PCSZ pcsz_DelimStop;
extern CHAR ch_Separator;
extern CHAR ch_Escape;
extern CHAR ch_Comment;
extern CHAR ch_Include;

/****************************************************************************/
/*                               Functions                                  */
/****************************************************************************/

BOOL StrSearchSkip (PCSZ pcszPattern,
                    istream & isIStream, ostream & osOStream);
BOOL StrSearchSkip (PCSZ pcszPattern, istream & isIStream,
                    STRING & strOut, INT iMaxLen = -1);

/****************************************************************************/

struct IdReplaceStrCmp
   {
   BOOL operator() (const STRING s1, const STRING s2) const
      {
      return (s1 == s2);
      }
   };

struct myHash {
   size_t operator()(const STRING & x) const
      {
      return __gnu_cxx::__stl_hash_string (x.c_str());
      }
   };

typedef HASH_MAP<STRING, STRING, myHash, IdReplaceStrCmp> HASH_MAP_STR_STR;

APIRET IdReplace (istream & isIStream, ostream & osOStream,
                  const HASH_MAP_STR_STR & hashMap,
                  INT &iFound, INT & iReplaced, INT &iError,
                  PCSZ pcszPrefix, PCSZ pcszSuffix, BOOL fRemove);

APIRET LoadMulti (istream & isIStream, PCSZ pcszInFile, 
                  HASH_MAP_STR_STR & hashMap);
APIRET LoadList  (istream & isIStream, PCSZ pcszInFile, 
                  HASH_MAP_STR_STR & hashMap);
APIRET LoadTable (istream & isIStream, PCSZ pcszInFile, 
                  HASH_MAP_STR_STR & hashMap);
                  
APIRET UnEscape (STRING & strData); 

APIRET InsertEntry (HASH_MAP_STR_STR & hashMap,
                    STRING strKey, STRING strData);
                  
/****************************************************************************/
#endif   // !defined (_MASARLABS_IDREPL_HPP_)
