/****************************************************************************/
/* |\   ======   /| **              IDRepl              ** |\   ======   /| */
/* |__\========/__| **       MasarLabs ID-Replacer      ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: verbose.hpp,v 1.4 2003/11/19 15:47:31 cvs Exp $
*****************************************************************************/
#ifndef  _MASARLABS_VERBOSE_HPP_
#define  _MASARLABS_VERBOSE_HPP_

/****************************************************************************/

#include <fstream>

using namespace std;

/****************************************************************************/
/* Global Variables                                                         */
/****************************************************************************/
extern ofstream MasarLabs_verbose_cnull;
extern int MasarLabs_verbose;

/****************************************************************************/
/** Return a stream depending on current verbose level.
***
*** Levels are:
*\B    -2 ERRORS
*\B    -1 WARNING
*\B     0 INFO
*\B     1 DEBUG
*\B     2 FULL DEBUG
***
*\C Parameters:
*\P   iLevel       IN - Level
*\P   iLine        IN - Stream to output
***
*\C Returns:
*\R   the stream
*****************************************************************************/
inline ostream& MasarLabsVerbose (int iLevel, ostream& oStream)
   {
   *Psz_RCS = *Psz_RCS;                 // To fake compiler warnings

   return (MasarLabs_verbose >= iLevel) ? oStream : MasarLabs_verbose_cnull;
   }

/****************************************************************************/
/** Return cerr for Error/Warning/Info/Debug/DebugFull output.
*****************************************************************************/
#define cerr_Error      MasarLabsVerbose(-2,cerr)
#define cerr_Warning    MasarLabsVerbose(-1,cerr)
#define cerr_Info       MasarLabsVerbose( 0,cerr)
#define cerr_Debug      MasarLabsVerbose( 1,cerr)
#define cerr_DebugFull  MasarLabsVerbose( 2,cerr)

/****************************************************************************/
/** Return cout for Error/Warning/Info/Debug/DebugFull output.
*****************************************************************************/
#define cout_Error      MasarLabsVerbose(-2,cout)
#define cout_Warning    MasarLabsVerbose(-1,cout)
#define cout_Info       MasarLabsVerbose( 0,cout)
#define cout_Debug      MasarLabsVerbose( 1,cout)
#define cout_DebugFull  MasarLabsVerbose( 2,cout)

/****************************************************************************/
#endif   // !defined (_MASARLABS_VERBOSE_HPP_)
